<template>
        <custom-table :data="state.permissions" :headers="state.headers" :pageSize="state.pageSize" :pageDisplayCount="4" :showButton="false"/>
</template>
  
<script>
import { reactive, onMounted } from 'vue';
import CustomTable from '@/components/custom-controller/CustomTable.vue';
import PermissionService from "@/services/PermissionService";
import eventBus from '@/plugins/eventBus';
import { Map } from '@/models/PermissionAndRoleModel.js';
import { setEncryptedList, getDecryptedList } from "@/utils/customEncryptionAndDecryption"
export default {
    components: {
        CustomTable,
    },
    setup() {
        const state = reactive({
            isOpenExpiressionPanel: true,
            panel: [0, 1],
            readonly: false,
            permissions: [],
            headers: ['Id', 'Adı', 'Açıklama', 'Görünen Adı','Durum', ' '],
            pageSize: 5,
        });

        const getAllPermission = () => {
            const permisssionsCache = getDecryptedList("permisssions")
            if (permisssionsCache) {
                state.permissions = Map(permisssionsCache,2)
            } else {
                PermissionService.GetAllPermission()
                    .then(response => {
                        const data = response.data.Response;
                        setEncryptedList(data, "permisssions")
                        state.permissions = Map(data,"permisssions")
                    })
                    .catch(error => {
                        console.log(error);
                    });
            }
        };

        onMounted(() => {  
            getAllPermission();
            eventBus.on('permission-added', function () {
                getAllPermission();
            });
        });

        return {
            state,
        };
    }
}
</script>
<style scoped>
@import "@/assets/styles/custom/custom-input.css";

</style>